<?xml version = "1.0" encoding="UTF-8"?>
<plugin
  id="de.grogra.plugin.manager"
  version="1.2"
  class="de.grogra.pm.PluginManager"
  xmlns="http://grogra.de/registry">
  
  <import plugin="de.grogra.imp3d"/>
  
  <!-- 
  <library file="commons-logging.jar" prefixes="{org.apache.commons.logging}"/>
  <library file="httpcore.jar" prefixes="{org.apache.http}"/>
  <library file="httpclient.jar" prefixes="{org.apache.http.client, org.apache.http.impl, org.apache.http.conn, org.apache.http.auth, org.apache.http.cookie}"/>
  <library file="json.jar" prefixes="{org.json}"/>
  -->
  <library file="Plugin-Manager.jar" prefixes="{de.grogra.pm}"/>


  <registry>
	<ref name="ui">
		<ref name="iconthemes">
	        <eval name="checkboxes">
	          <object expr="de.grogra.icon.ScaledIconTheme.readFromDirectory">
	            <string value="icontheme"/>
	            <resource name="icons"/>
	            <string value=".png"/>
	          </object>
	        </eval>
	    </ref>
	</ref>
	
    <directory name="pluginmanager" optionCategory="true" elements="{{panel,de.grogra.pf.ui.registry.PanelFactory}}">
    	<null name="options">
			<option name="mainRepo" type="java.lang.String" value="https://grogra.gitlab.io/groimp-utils/plugin_web_explorer/plugins.json"/>
			<option name="userpluginpath" type="java.lang.String" value=""/>
			<option name="useCache" type="java.lang.Boolean" value="true"/>
			<option name="sourceCachePath" type="java.lang.String" value=""/>
			<option name="pluginCachePath" type="java.lang.String" value=""/>
			<option name="userDefinedRepo" type="java.lang.String" value=""/>
			<option name="deleteAsBlacklist" type="java.lang.Boolean" value="false"/>
			<option name="canDeteteRequired" type="java.lang.Boolean" value="false"/>
			<null name="proxy" optionCategory="true">
				<option name="proxy.user" type="java.lang.String" value=""/>
				<option name="proxy.password" type="java.lang.String" value=""/>
				<option name="proxy.domain" type="java.lang.String" value=""/>
				<option name="http.proxy.host" type="java.lang.String" value=""/>
				<option name="http.proxy.port" type="java.lang.String" value=""/>
				<option name="https.proxy.host" type="java.lang.String" value=""/>
				<option name="https.proxy.port" type="java.lang.String" value=""/>

			</null>
		</null>
		
		
		<directory name="commands">
			<directory name="file">
				<command name="exportPlugins" run="de.grogra.pm.PluginManager.exportPluginList"/>
				<command name="importPlugins" run="de.grogra.pm.PluginManager.importPluginList"/>
			</directory>
			<directory name="data">
				<command name="reloadRepo" run="de.grogra.pm.PluginManager.reloadRepositories"/>
				<command name="clearCache" run="de.grogra.pm.PluginManager.clearCache"/>
				<command name="recreatehttp" run="de.grogra.pm.PluginManager.reloadHTTPClient"/>
			</directory>
			<command name="installCMD" run="de.grogra.pm.PluginManager.installCMD"/>
			<command name="uninstallCMD" run="de.grogra.pm.PluginManager.uninstallCMD"/>
			<command name="disableCMD" run="de.grogra.pm.PluginManager.disableCMD"/>

			<command name="selectVersion" run="de.grogra.pm.PluginManager.selectVersion"/>
			<command name="applyChanges" run="de.grogra.pm.PluginManager.applyChanges"/>
			<command name="describePlugin" run="de.grogra.pm.PluginManager.describePlugin"/>
			<command name="describeAllPlugins" run="de.grogra.pm.PluginManager.describeAllPlugins"/>
			<command name="setAllUpgrade" run="de.grogra.pm.PluginManager.setAllUpgrade"/>


			<command name="openPmGUI">
			<void method="de.grogra.pf.ui.Workbench.openAsDemo">
				<var name="item" />
				<resource name="Plugin Manager.gsz" />
				<var name="context" />
			</void>
			</command>
			
		</directory>
    </directory>
    
	<ref name="ui">
		<ref name="panels">
			<panel name="pluginmanager" hidden="true">
	          <object expr="de.grogra.pm.gui.PluginManagerDialog.createPanel">
	            <var name="context"/>
	            <vars/>
	          </object>
	    		<directory name="menu">
	              <directory name="src">
	                <link source="/pluginmanager/commands/file"/>
	                <link source="/pluginmanager/commands/data"/>
	              </directory>
	            </directory>
	    	</panel>
	    	<panel name="pluginpanel" hidden="true">
	          <object expr="de.grogra.pm.PluginManager.createPluginPanel">
	            <var name="context"/>
	            <vars/>
	          </object>
	    	</panel>
	    </ref>
	</ref>

    
    <ref name="hooks">
      <ref name="configure">
        <ref name="main">
          <insert target="/workbench/menu/src/help" resolveLinks="false">
			<link source="/pluginmanager/commands/openPmGUI" />
          </insert>
        </ref>
      </ref>
    </ref>
    
  </registry>
</plugin>
